//import std.stdio;

import tango.io.Stdout;
import tango.core.Tuple;

import rtti;

void show(RttiData data) {
    version(Tango)
        Stdout(data.toString()).newline.newline;
    else
        writefln(data, '\n');
}

void main() {
    version(NoUnitTest) {   // because of DMD bug #902, can't use rtti from multiple modules
    
    // Simple aggregates:
    show(Rtti!(Class1));
    show(Rtti!(Struct));
    show(Rtti!(Union));
    show(Rtti!(EmptyStruct));
    
    // Inheritance
    show(Rtti!(Object));
    show(Rtti!(Base));
    show(Rtti!(Derived));
    show(Rtti!(Leaf));
    
    typedef Leaf Foliage;
    show(Rtti!(Foliage));
    
    show(Rtti!(Union[]));
    show(Rtti!(char[5]));
    show(Rtti!(int[char[]]));
    show(Rtti!(int[char]));
    show(Rtti!(Union[int]));
    show(Rtti!(bool[TypeInfo]));
    show(Rtti!(void[]));
    
    show(Rtti!(void function()));
    show(Rtti!(void delegate()));
    
    Stdout.flush();
    } // version(NoUnitTest)
}

interface Interface { void foo(); }
//interface Interface2 { }
//interface Interface3 { }
//interface Interface4 { }

class Base : Interface { double f ; void foo() {} }
//class Base : Interface , Interface2, Interface3, Interface4 { double f ; void foo() {} }
class Derived : Base, Interface { short s; byte b; void foo() {} }
//class Derived : Base { byte b; double d; void foo() {} }
class Leaf : Derived { }

class Class1 {
    Class2 c2;
    void* nil;
    int blaat;
    Struct* other;
    Struct tree;
}

//class Class2 { Union u; }
class Class2 { Class1 loop; }

struct EmptyStruct {}

struct Struct {
    Struct* left, right;
    int[20] data;
    Class2 test;
}

union Union {
    char c;
    long l;
    int data;
    ubyte[long.sizeof] raw;
    Struct* s;
}
